//============================================================================
// Name        : TCCP.cpp
// Author      : qwan
// Version     :
// Copyright   : Your copyright notice
// Description : Hello World in C++, Ansi-style
//============================================================================

#include <stdio.h>
#include <time.h>
#include <vector>
#include <set>
#include <stack>
#include "setting.h"
#include "lib/space.h"

#define BILLION  1000000000L;
#define _MAX 6553500
#define _LIST_UNDEFINED 0

extern int load_file();
extern int price_dom(int q);
extern int price_comp(int q);
extern int price_dom(int q, PtsSpace* local_created);
extern int price_comp(int q, PtsSpace* local_created);
extern int price_con(int q, Pt_Collection* pc);
extern int delta(int q);
extern int delta(int q, Pt_Collection* pc);
extern int cal_profit(Pt_Collection* pc);
extern void release_all();
extern PtsSpace* created, *exsiting;
extern Setting setting;

extern double add_error, big_delta;
extern double profit_greedy0, profit_optimal;

extern float userTime_prep, sysTime_prep;
extern float userTime_algo1, sysTime_algo1;
extern float userTime_algo2, sysTime_algo2;
extern float userTime_algo3, sysTime_algo3;
extern float userTime_algo4, sysTime_algo4;
extern float userTime_algo5, sysTime_algo5;
extern float userTime_overall, sysTime_overall;

extern struct rusage myTime_program_start, myTime_prep_end,
		myTime_algo1_end, myTime_algo2_end, myTime_algo3_end,myTime_algo4_end,myTime_algo5_end, myTime_end;

extern void printTimeFile();

/* greedy algorithm v1
 *
 * description:
 * see Algorithm 4 Greedy algorithm (Version 1)
 * */

void greedy0() {

	int* unsorted = new int[created->tupleNum];
	int* index = new int[created->tupleNum];

	for (int i = 0; i < created->tupleNum; i++) {
		unsorted[i] = delta(i);
		index[i] = i;
		//printf("%d, %d,%d \n", unsorted[i], index[i],i);
	}

	quicksort_i(index, unsorted, 0, created->tupleNum - 1);

	int sum = 0;

	for (int i = 0; i < setting.k; i++) {
		sum += unsorted[i];
	}

	big_delta = sum;

	int profit = 0;

	Pt_Collection* s = new Pt_Collection;

	printf("greedy 0: ");

	for (int i = 0; i < setting.k; i++) {
		printf("%d:", index[i]);
		s->insert(index[i]);
	}

	printf("\n");

	FILE* ptr = (FILE *) fopen("output_greedy0", "w");

	profit = cal_profit(s);
	long mem = created->count();
	mem += exsiting->count();
	mem += sizeof(int) * created->tupleNum * 4;

	fprintf(ptr, "%d,%ld", profit, mem);

	fclose(ptr);

	add_error -= profit;
	profit_greedy0 = profit;

	delete s;
	delete[] unsorted;
	delete[] index;
}
;

/*
void greedy1() {

	int max = -_MAX, max_index = -1;

	for (int i = 0; i < created->tupleNum; i++) {
		int tp = delta(i);
		if (max < tp) {
			max = tp;
			max_index = i;
		}
	}

	if (max_index == -1) {
		printf("problem unsolvable!!!");
	}

	Pt_Collection* s = new Pt_Collection;

	for (int i = 0; i < setting.k; i++) {

		//printf("round %d \n", i);

		max = -_MAX;
		s->insert(max_index);
		for (int j = 0; j < created->tupleNum; j++) {

			if (s->find(j) != s->end())
				continue;

			int tp = delta(j, s);
			if (max < tp) {
				max = tp;
				max_index = j;
			}
		}
	}

	printf("output 1: ");

	for (Pt_Collection::iterator iter = s->begin(); iter != s->end(); iter++) {
		printf("%d:", *iter);
	}

	FILE* ptr = (FILE*) fopen("output_greedy1", "w");

	int profit = cal_profit(s);

	long mem = created->count();
	mem += exsiting->count();

	mem += sizeof(int) * created->tupleNum * 4;

	fprintf(ptr, "%d,%ld", profit, mem);

	fclose(ptr);

	delete s;
}
;
*/


void greedy1() {

	int max = -_MAX, max_index = -1;

	for (int i = 0; i < created->tupleNum; i++) {
		int tp = delta(i);
		if (max < tp) {
			max = tp;
			max_index = i;
		}
	}

	if (max_index == -1) {
		printf("problem unsolvable!!!");
	}

	Pt_Collection* s = new Pt_Collection;

	for (int i = 0; i < setting.k; i++) {

		//printf("round %d \n", i);

		max = -_MAX;
		s->insert(max_index);
		for (int j = 0; j < created->tupleNum; j++) {

			if (s->find(j) != s->end())
				continue;

			s->insert(j);
			int tp = cal_profit(s);
			s->erase(j);

			if (max < tp) {
				max = tp;
				max_index = j;
			}
		}
	}

	printf("greedy 1: ");

	for (Pt_Collection::iterator iter = s->begin(); iter != s->end(); iter++) {
		printf("%d:", *iter);
	}

	printf("\n");


	FILE* ptr = (FILE*) fopen("output_greedy1", "w");

	int profit = cal_profit(s);
	long mem = created->count();
	mem += exsiting->count();
	mem += sizeof(int) * created->tupleNum * 4;

	fprintf(ptr, "%d,%ld", profit, mem);

	fclose(ptr);

	delete s;
}
//
//void randomized() {
//
//	srand(time(0));
//
//	int* unsorted = new int[created->tupleNum];
//	int* index = new int[created->tupleNum];
//
//	for (int i = 0; i < created->tupleNum; i++) {
//		unsorted[i] = delta(i);
//		index[i] = i;
//	}
//
//	int base = (setting.k * 10) % created->tupleNum;
//	int max_profit = 0;
//
//	int numOfround = 100000;
//
//	if (created->tupleNum > 50000) {
//		numOfround = 10000;
//	}
//
//	quicksort_i(index, unsorted, 0, created->tupleNum - 1);
//
//	Pt_Collection* s = new Pt_Collection;
//
//	for (int run = 0; run < numOfround; run++) {
//		if (run % 1000 == 0) {
//			printf("%f \% \n", run * 100.0 / numOfround);
//		}
//
//		for (int i = 0; i < setting.k; i++) {
//			int seed = rand() % base;
//			while (s->find(index[seed]) != s->end()) {
//				seed++;
//			}
//			s->insert(index[seed]);
//		}
//
//		int temp_profit = cal_profit(s);
//
//		if (temp_profit > max_profit)
//			max_profit = temp_profit;
//
//		s->clear();
//	}
//
//	FILE* ptr = (FILE*) fopen("output_randomized", "w");
//
//	fprintf(ptr, "%d", max_profit);
//
//	fclose(ptr);
//
//}

void burtoforce(Pt_Collection & s, int index, int& max_profit) {

	if (s.size() == setting.k) {

		//quick check
		int temp_profit = 0;

		for (Pt_Collection::iterator iter = s.begin(); iter != s.end(); iter++) {
			temp_profit += delta(*iter);
		}

		if (temp_profit < max_profit) {
			return;
		}

		//common check
		temp_profit = cal_profit(&s);

		if (max_profit < temp_profit) {
			//printf("\n=================\n");


			//			for(Pt_Collection::iterator iter = s.begin();iter != s.end();iter++){
			//				printf("%d ",*iter);
			//			}

			//printf("\n=================\n");
			max_profit = temp_profit;
		}

	} else {
		for (int i = index; i < created->tupleNum; i++) {
			s.insert(i);
			burtoforce(s, i + 1, max_profit);
			s.erase(i);
		}
	}

	return;
}


/*
 * burteforce solution
 * */
void run_burteforce() {

	int max = 0, index = 0;
	Pt_Collection s;

	burtoforce(s, index, max);

	FILE* ptr = (FILE*) fopen("output_burteforce", "w");

	long mem = created->count(); //table created
	mem += exsiting->count(); //table existing
	mem += sizeof(int) * created->tupleNum * 4; //cache
	fprintf(ptr, "%d,%ld", max, mem);

	add_error = max;
	profit_optimal = max;

	fclose(ptr);
}

void dp2d() {

	//created->show();

	Pt_Collection** SS = new Pt_Collection*[created->tupleNum];
	int** TT = new int*[created->tupleNum];

	for (int i = 0; i < created->tupleNum; i++) {
		SS[i] = new set<int> [setting.k + 1];
		TT[i] = new int[setting.k + 1];
		memset(TT[i], 0, (setting.k + 1) * sizeof(int));
	}

	for (int i = 1; i < created->tupleNum; i++) {
		for (int t = 1; t < setting.k + 1; t++) {

			if (t > i)
				continue;

			int d = delta(i, &SS[i - 1][t - 1]);

			if (t > i - 1) {
				SS[i][t].insert(SS[i - 1][t - 1].begin(),
						SS[i - 1][t - 1].end());
				SS[i][t].insert(i);
				TT[i][t] = TT[i - 1][t - 1] + d;

				continue;

			}

			if (TT[i - 1][t - 1] + d > TT[i - 1][t]) {
				SS[i][t].insert(SS[i - 1][t - 1].begin(),
						SS[i - 1][t - 1].end());
				SS[i][t].insert(i);

				TT[i][t] = TT[i - 1][t - 1] + d;

				//printf("%d \n",TT[i][t]);

			} else {
				SS[i][t].insert(SS[i - 1][t].begin(), SS[i - 1][t].end());
				TT[i][t] = TT[i - 1][t];

			}

		}
	}

	printf("dp : ");

	for (Pt_Collection::iterator i =
			SS[created->tupleNum - 1][setting.k].begin(); i
			!= SS[created->tupleNum - 1][setting.k].end(); i++) {
		printf("%d:", *i);
	}

	printf("\n");

//	for (int i = 1; i < created->tupleNum; i++) {
//		for (int t = 1; t < setting.k + 1; t++) {
//			//printf("%d ", TT[i][t]);
//		}
//		printf("\n");
//	}

	FILE* ptr = (FILE*) fopen("output_dp", "w");

	long mem = created->count(); //table created
	mem += exsiting->count(); //table existing
	mem += sizeof(int) * created->tupleNum * 4; //cache

	mem += created->tupleNum * setting.k * sizeof(int); //TT
	mem += created->tupleNum * setting.k * sizeof(int) * (setting.k / 2) * 3; //SS

	int max_profit = cal_profit(&SS[created->tupleNum - 1][setting.k]);

	fprintf(ptr, "%d,%ld", max_profit, mem);

	fclose(ptr);

}


int main(int argc, char** argv) {

	getrusage(RUSAGE_SELF, &myTime_program_start);

	if (argc != 5) {
		printf("algorithm requires 4 parameters, k, h, d, sigma\n");
		exit(0);
	}

	setting.k = atoi(argv[1]);
	setting.h = atoi(argv[2]);
	setting.d = atof(argv[3]);
	setting.sigma = atoi(argv[4]);

	load_file();

	getrusage(RUSAGE_SELF, &myTime_prep_end);
	//run_burteforce();
	//note that when k >= 5, run_burteforce could be very slow
	getrusage(RUSAGE_SELF, &myTime_algo1_end);
	greedy0();
	getrusage(RUSAGE_SELF, &myTime_algo2_end);
	greedy1();
	getrusage(RUSAGE_SELF, &myTime_algo3_end);
	dp2d();
	getrusage(RUSAGE_SELF, &myTime_algo4_end);


	/*
	 * only used to evluate greedy v1 in the paper


	double add_bound = setting.k * (setting.k -1) /2 * setting.sigma;
	double mult_bound = add_bound / big_delta;
	double mult_error = 1-profit_greedy0 / profit_optimal;
	// you have to run run_burteforce to know the profit_optimal

	printf("%lf,%lf,%lf,%lf \n",add_error,add_bound,mult_error,mult_bound );

	 * */

	printTimeFile();

	return 0;
}
