/*
 * CSet.h
 *
 *  Created on: Feb 22, 2009
 *      Author: qwan
 */

#ifndef CSET_H_
#define CSET_H_

#include <stdio.h>
#include <string.h>

#define _BUFLEN 800000001

typedef char BYTE;

class CSet {
public:
	BYTE* ptr;
	int curr;
	int dim;
	int* dimLen; //0- from low to high
	int* accDimCount;
	char* msk_array;
	int full;
	bool inited;

public:

	CSet() {
		ptr = new BYTE[_BUFLEN];
		memset(ptr, 0, _BUFLEN);
		inited = false;
		char init = 0x01;
		msk_array = new char[8];

		for (int i = 0; i < 8; i++) {
			msk_array[i] = (char) init;
			init *= 2;
		}
	}

	~CSet() {
		delete[] ptr;
		delete[] msk_array;
		if (inited) {
			delete[] dimLen;
			delete[] accDimCount;
		}
	}

	void setDimeLen(int* dl);
	void setBit(int index, bool val);
	void revBit(int index);
	bool getBit(int index);
	int mapping(int* vector);
	int* remapping(int index);
	int* next();
	bool isoverflow();
	bool check(int index);

	void print();

	void init(int d, int* dl) {

		if (inited) {
			return;
		}

		dim = d;
		dimLen = dl;
		curr = 0;

		int k = 1;
		accDimCount = new int[dim];

		for (int i = 0; i < dim; i++) {
			accDimCount[dim - i - 1] = k;
			k *= dimLen[i];
		}

		inited = true;
		full = dimLen[dim - 1] * accDimCount[0];

	}

	void clear() {

		if (!inited) {
			return;
		}

		memset(ptr, 0, _BUFLEN);
		delete[] dimLen;
		delete[] accDimCount;
		inited = false;
	}

};

#endif /* CSET_H_ */
